package jive.erlang;

/**
 * Receive thread is a class that creates a thread that delivers a 
 * message to a specific receiver.
 *
 * This class is only used in the Unpacker class.
 *
 * @version     1.2, 8 Mar 1997
 * @author      Kaj Nygren (kaj@medialab.ericsson.se)
 * @author      Joakim Greben&ouml; (jocke@erix.ericsson.se)
 */
class ReceiveThread implements Runnable {
  
  EReceive target;
  EVar message;
  Thread receiveThread;
  
  /**
   * Creates a new Thread that will deliver the message to the
   * target receiver and then dies.
   */
  protected ReceiveThread(EReceive target, EVar message) {
    this.target  = target;
    this.message = message;
    receiveThread = new Thread(this);
    receiveThread.start();
  }
  
  /**
   * This method is executed by the thread. It delivers the message
   * and dies.
   */
  public void run() {
    target.receive(message);
  }
}
